#!/usr/bin/perl

print "GnuPod 0.1 -> 0.2 converter\n";

if(!-d $ARGV[0])
{
 print "Usage:\nconvdb.pl IPOD_MOUNTPOINT\n";
 exit(1);
}

stdtest();


open(OF, "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") or die "Could not open old gnutunes: $!\n";
print "> reading old file\n";
 while(defined($i=<OF>))
 {
 $count++;
  chomp($i);
  $i = xmlstring($i);
  (@foo) = split(/\t/, $i);
   if(int(@foo) != 7 && int(@foo))
   {
    die "Invalid entry at line $count, doesn't look like a gnuPod 0.1 file\n..suicide\n";
   }
  $ret .= "<file id=\"$count\" bitrate=\"$foo[1]\" filesize=\"$foo[3]\" time=\"$foo[2]\" title=\"$foo[4]\" artist=\"$foo[5]\" album=\"$foo[6]\" path=\"$foo[0]\" />\n";
 }
close(OF);

print "..done, writing file in new format\n";


open(OF, "> $ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") or die "Could not open old gnutunes: $!\n";
print OF "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<gnuPod>\n<files>\n";
print OF $ret;
print OF "\n</files>\n</gnuPod>\n";
close(OF);
print "Done!\n\nThe iPod is now ready for gnuPod 0.2!\n";





sub stdtest
{
if(!(-w "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB"))
{
 print "Error: Cant write to your gnuPod-file\n";
 exit(1);
}


if ((-M "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") > (-M "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: your gnuPod-file is older than your iTunesDB! (Last update not done with gnuPod?)\n";
 print "Please run this command to correct this issue:\n";
 print "tunes2pod.pl \$IPOD_MOUNTPOINT/iPod_Control/iTunes/iTunesDB > \$IPOD_MOUNTPOINT/iPod_Control/.gnupod/GNUtunesDB\n\n";
 print "This comment will update your current gnuPodfile with the contents of your (newer) iTunesDB\n";
 
 exit(1);
}

return 0;
}



sub xmlstring
{
my($ret) = @_;
$ret =~ s/&/&amp;/g;
$ret =~ s/"/&quot;/g;
$ret =~ s/</&lt;/g;
$ret =~ s/>/&gt;/g;
$ret =~ s/'/&apos;/g;
return $ret;
}


